/*************************************************************************************************
* Description:	com support file for NBIT sensor 
* Author:		xiaofei.huang
* Versions:		V1.0
* Date:         2017-07-06
* Modifiy:
* CO.ltd:       
* Other:
*************************************************************************************************/
#include "comm.h"
/*************************************************************************************************
* Function Name  : open_com.
* Description    : 򿪴.
* Input          : com    - ں.
* Return         : HANDLE - 豸.
**************************************************************************************************/
HANDLE open_com(LPCWSTR com)
{
	HANDLE hCOM = INVALID_HANDLE_VALUE;
#ifdef SYNC
	hCOM = CreateFile(com,							// ,磺"COM1"					
		GENERIC_READ|GENERIC_WRITE,					// д,磺GENERIC_READ|GENERIC_WRITE
		0,											// ռʽ0
		NULL,										// NULL
		OPEN_EXISTING,								// 򿪶Ǵ:OPEN_EXISTING
		0,											// ͬʽ:0,	첽ʽFILE_FLAG_OVERLAPPED
		NULL);										// NULL
#else
	hCOM = CreateFile(com,							// ,磺"COM1"					
		GENERIC_READ|GENERIC_WRITE,					// д,磺GENERIC_READ|GENERIC_WRITE
		0,											// ռʽ0
		NULL,										// NULL
		OPEN_EXISTING,								// 򿪶Ǵ:OPEN_EXISTING
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_OVERLAPPED,	// ͬʽ:0,	첽ʽFILE_FLAG_OVERLAPPED
		NULL);										// NULL
#endif
	return hCOM;	
}
/*************************************************************************************************
* Function Name  : config_com.
* Description    : ô.
* Input          : hcom    - 豸.
*                bufsize - շݻС
*                baud    - 
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL config_com(HANDLE hcom,DWORD bufsize,DWORD baud)
{
	DCB				Mcomm_DCB;  // 
	COMMTIMEOUTS	Mcomm_TIMES;// ʱ

	if(hcom == INVALID_HANDLE_VALUE) return FALSE;

	GetCommState(hcom,&Mcomm_DCB);
	Mcomm_DCB.BaudRate = baud;							// 
	Mcomm_DCB.ByteSize = 8;								// ÿֽ8 λ
	Mcomm_DCB.Parity   = NOPARITY;						// żУλ
	Mcomm_DCB.StopBits = ONESTOPBIT;					// һֹͣλ

	if (!SetCommState(hcom, &Mcomm_DCB))				// ôڲ,Ƿɹ
	{
		return FALSE;
	}

	Mcomm_TIMES.ReadIntervalTimeout = 100;				// ʱ	
	if (!SetCommTimeouts(hcom, &Mcomm_TIMES))			// óʱǷɹ
	{
		return FALSE;
	}

	//---------------------------------------- ʼò --------------------------------------------
	SetupComm(hcom, bufsize, bufsize);					// С

	PurgeComm(hcom,PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR|PURGE_RXCLEAR);		// 

	return TRUE;
}
/*************************************************************************************************
* Function Name  : close_com.
* Description    : رմ.
* Input          : hcom    - 豸.
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL close_com(HANDLE hcom)
{
	if(hcom == INVALID_HANDLE_VALUE) return FALSE;

	CloseHandle(hcom);

	return TRUE;
}
/*************************************************************************************************
* Function Name  : com_send_data.
* Description    : .
* Input          : hcom    - 豸.
*                buf     - ݻ
*                len     - ݳ
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL com_send_data(HANDLE hcom,char* buf,DWORD len)
{
	BOOL ret = FALSE;
#ifdef  SYNC
	COMSTAT ComStat;										// 豸ǰ״̬
	DWORD	ErrorFlags;										// 
	DWORD   WritenSize = 0;

	if(hcom == INVALID_HANDLE_VALUE) return FALSE;

	if(len == 0) return FALSE;

	ClearCommError(hcom,&ErrorFlags,&ComStat);				// ӲͨѶԼȡͨѶ豸ĵǰ״̬

	ret = WriteFile(hcom, buf, len,&WritenSize,NULL);		// д

	if(!ret)											    // жǷдɹ
	{
		return FALSE;
	}
#else	
	if (hcom == INVALID_HANDLE_VALUE)	return FALSE;
	if (len == 0)						return FALSE;

	// OVERLAPPED: 첽ϢĽṹ
	//           : Ҫϵͳ,ڴʱ֪ͨ
	OVERLAPPED	EventWrite;										// ¼
	memset(&EventWrite,0,sizeof(OVERLAPPED));
	EventWrite.hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);		// һ¼

	COMSTAT		ComStat;										// 豸ǰ״̬
	DWORD		ErrorFlags;										// ״̬
	ClearCommError(hcom,&ErrorFlags,&ComStat);					// ӲͨѶԼȡͨѶ豸ĵǰ״̬

	DWORD		dword;											// 
	ret = WriteFile(hcom, buf, len,&dword,&EventWrite);			// д

	if(!ret)													// жǷдɹ
	{
		if(GetLastError() == ERROR_IO_PENDING)
		{
			WaitForSingleObject(EventWrite.hEvent,1000);		// ʱȴ
		}
	}
#endif
	return TRUE;
}
/*************************************************************************************************
* Function Name  : com_read_data.
* Description    : .
* Input          : hcom    - 豸.
*                buf     - ݻ
*                len     - ݳ
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL com_read_data(HANDLE hcom,char *buf,DWORD len)
{
	BOOL ret = FALSE;
#ifdef SYNC
	DWORD   ReadSize = 0;

	if(hcom == INVALID_HANDLE_VALUE) return FALSE;

	if(!len)  return FALSE;

	ret = ReadFile(hcom, buf, len,&ReadSize,NULL);

	if(!ret) return FALSE;

#else 
	if(hcom == INVALID_HANDLE_VALUE)	return FALSE;
	if(len <= 0)						return FALSE;

	OVERLAPPED	EventRead;
	memset(&EventRead,0,sizeof(OVERLAPPED));
	EventRead.hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);

	DWORD		ErrorFlags;
	COMSTAT		ComStat;									// 豸ǰ״̬
	ClearCommError(hcom,&ErrorFlags,&ComStat);				// ӲͨѶԼȡͨѶ豸ĵǰ״̬

	DWORD		dword;
	ret = ReadFile(hcom, buf, len,&dword,&EventRead);
	if(!ret)											   
	{													  
		if(GetLastError()==ERROR_IO_PENDING)
		{
			WaitForSingleObject(EventRead.hEvent,2000);
		}	
	}		

	PurgeComm(hcom,PURGE_RXABORT | PURGE_RXCLEAR | PURGE_TXABORT | PURGE_TXCLEAR);
#endif
	return ComStat.cbInQue;
}




