/*************************************************************************************************
* Description:	socket support file
* Author:		xiaofei.huang
* Versions:		V1.0
* Date:         2017-07-06
* Modifiy:
* CO.ltd:
* Other:
*************************************************************************************************/
#pragma once

#include "sock.h"
/*************************************************************************************************
* Function Name  : stringconv.
* Description    : IPַַת.
* Input          : p  - IPַ.
* Return         : s  - ת.
**************************************************************************************************/
void stringconv(unsigned char *p, char *s)
{
	int LoopCount = 0;
	int AddCount  = 0;
	int Temp[3]	  = {0};

	for (int i = 0; i < 4; i++)
	{
		Temp[LoopCount] = (p[i] / 100);

		if (Temp[LoopCount]) LoopCount++;

		Temp[LoopCount] = (p[i] - (p[i] / 100) * 100) / 10;

		if (Temp[LoopCount]) LoopCount++;

		Temp[LoopCount] = (p[i] - (p[i] / 10) * 10);

		if (Temp[LoopCount]) LoopCount++;

		if (LoopCount == 0)
		{
			s[AddCount + LoopCount] = '0';

			AddCount++;

			s[AddCount + LoopCount] = '.';

			AddCount++;
		}
		else
		{
			for (int k = 0; k < LoopCount; k++)
			{
				s[AddCount + k] = Temp[k];
			}

			s[AddCount + LoopCount] = '.';

			LoopCount++;

			AddCount += LoopCount;
		}

		LoopCount = 0;
	}

	s[AddCount - 1] = 0;
}
/*************************************************************************************************
* Function Name  : InitSocket.
* Description    : Socket׽.
* Input          : NONE.
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL InitSocket()
{
	WORD	wVersionRequested;
	WSADATA wsaData;
	int		err=0;
	//---------------- Windows첽׽ֵ -----------------
	wVersionRequested = MAKEWORD( 2, 2 );			// 汾
	err = WSAStartup( wVersionRequested, &wsaData );//  

	if (err != 0)									// жǷɹ
	{
		return false;
	}
	//--------------------------- 汾ж -------------------------
	if ( LOBYTE( wsaData.wVersion ) != 2 ||
		 HIBYTE( wsaData.wVersion ) != 2 ) 
	{
		WSACleanup();
		return false; 
	}

	return true;
}
/*************************************************************************************************
* Function Name  : udpInitClient.
* Description    : udpͻ˳ʼ.
* Input          : Msock   - sock.
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL udpInitClient(Msock *p)
{
	char m_Addr[32];
	char m_Addrcopy[32];

    strncpy(m_Addrcopy,p->gseriveIP.c_str(),32);

	for(int i = 0;i < 32;i += 2)
	{
		m_Addr[i/2] = m_Addrcopy[i];
	}
	//stringconv(p->gseriveIP, m_Addr);
	//---------------------- ͻ˵ַ ---------------------------
	p->gaddrserve.sin_family = AF_INET;

    p->gaddrserve.sin_addr.s_addr = inet_addr(m_Addrcopy);//(m_Addr);
															// IPַ0.0.0.0 INADDR_ANY -ַָΪ0.0.0.0ĵַ
															// htonl - ת޷ų͵ֽ˳
															// дɣinet_addr("0.0.0.0");
	p->gaddrserve.sin_port		  = htons(p->gserveport);	// ˿




    // htons - ޷Ŷתֽ˳
	//---------- һָͷṩ׽ӿ -----------
	p->gsocketclient = WSASocket(AF_INET,					// af   - ַ淶Ŀǰ֧AF_INETʽ
								 SOCK_DGRAM,				// type - ׽ӿڵ SOCK_STREAM - ,һtcp/ipЭı SOCK_DGRAM - ݱ,udpЭ
								 IPPROTO_UDP,				// protocol - ׽ӿʹõضЭ飬߲ԸָЭΪ0
								 NULL,						// lpProtocolInfo - һָPROTOCOL_INFOṹָ룬ýṹ׽ӿڵ
								 0,							// g - δʹõ׽顣׽ӿıʶ
								 0);						// iflags - ׽ӿ


	if(p->gsocketclient == INVALID_SOCKET)					// жϴǷɹ
	{
		return false;
	}	






	ioctlsocket(p->gsocketclient,FIONBIO,(u_long FAR*)&p->gsockmode);
	//--------------------- ʼͺͽջ ---------------------
	p->gaddrserveLen = sizeof(p->gaddrserve);

	return true;
}
/*************************************************************************************************
* Function Name  : udpSendClient.
* Description    : UDPͻ˷.
* Input          : Msock   - sock.
*                buf     - ݻ.
*                len     - ݳ.
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL udpSendClient(Msock *p,char *buf,int len)
{
	int ret;

	ret = sendto(p->gsocketclient, buf, len, 0, (sockaddr*)&p->gaddrserve, p->gaddrserveLen);

	if (ret == SOCKET_ERROR)
	{
		return false;
	}

	return true;
}
/*************************************************************************************************
* Function Name  : udpSendClient.
* Description    : UDPͻ˽.
* Input          : Msock   - sock.
*                buf     - ݻ.
*                len     - ݳ.
* Return         : int     - յݳ.
**************************************************************************************************/
int udpRecvClient(Msock *p, char *buf,int len)
{
	int ret = SOCKET_ERROR;

	ret = recvfrom(p->gsocketclient, buf, len,0, (sockaddr*)&p->gaddrserve,&p->gaddrserveLen);
	if (ret == SOCKET_ERROR)
	{
		return 0;
	}

	return ret;
}
/*************************************************************************************************
* Function Name  : udpClientClose.
* Description    : UDPͻ˶Ͽ.
* Input          : Msock   - sock.
* Return         : BOOL    - TRUE - óɹ FALSE - ʧ.
**************************************************************************************************/
BOOL udpClientClose(Msock *p)
{
	closesocket(p->gsocketclient);
	WSACleanup();
	return true;
}


